package io.github.null2264.tsukumogami.core.commands.converters.impl

import io.github.null2264.tsukumogami.core.Context
import io.github.null2264.tsukumogami.core.commands.StringParser
import io.github.null2264.tsukumogami.core.commands.converters.Converter
import io.github.null2264.tsukumogami.core.exceptions.CommandException
import java.net.URI
import java.net.URL

class URLConverter : Converter<URL>() {

    override var isGreedy: Boolean
        get() = false
        set(_) { error("HttpConverter can't be greedy") }

    override lateinit var parsed: URL

    override suspend fun consume(context: Context, parser: StringParser): Boolean {
        if (!parser.hasNext()) return false
        val input = parser.peekNext()
        this.parsed = try {
            URL(input)
        } catch (e: Exception) {
            throw CommandException("Failed to parse URL", e)
        }
        parser.next()
        return true
    }
}
